<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item :label="systemName+'号'" prop="usercode">
        <el-input
            v-model="queryParams.usercode"
            :placeholder="'请输入'+systemName+'号'"
            clearable
            @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="手机号" prop="mobile">
        <el-input
            v-model="queryParams.mobile"
            placeholder="请输入手机号"
            clearable
            @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['cai:anchorBanner:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['cai:anchorBanner:remove']"
        >删除</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="anchorBannerList" @selection-change="handleSelectionChange">
      <el-table-column :label="systemName+'号'" align="center" prop="usercode"/>
      <el-table-column label="昵称" align="center" prop="nickname"/>
      <el-table-column label="手机" align="center" prop="mobile"/>
      <el-table-column label="头像" align="center" prop="avatar">
        <template v-slot="scope">
          <image-avatar :src="scope.row.avatar"/>
        </template>
      </el-table-column>
      <el-table-column label="性别" align="center" prop="gender">
        <template v-slot="scope">
          <cai-dict-tag :options="genderList" :value="scope.row.gender"/>
        </template>
      </el-table-column>
      <el-table-column label="开启状态" align="center" prop="openStatus" >
        <template v-slot="scope">
          <el-switch
              v-model="scope.row.openStatus"
              :active-value="1"
              :inactive-value="0"
              @change="handleOpenStatusChange(scope.row)"
          ></el-switch>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['cai:anchorBanner:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <add-anchor-banner-dialog v-if="addAnchorBannerDialogVisible" ref="addAnchorBannerDialog"  @refreshDataList="getList"  />
  </div>
</template>

<script>
import {delAnchorBanner, listAnchorBanner, updateAnchorBanner} from "@/api/cai/anchorBanner";
import AddAnchorBannerDialog from "@/views/cai/anchorBanner/add-anchor-banner-dialog.vue";
import {genderList} from "@/constant/statusMap";

export default {
  name: "AnchorBanner",
  components: { AddAnchorBannerDialog},
  data() {
    return {
      genderList,
      systemName: process.env.VUE_APP_SYSTEM_HOME,
      addAnchorBannerDialogVisible: false,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 主播首页推荐表格数据
      anchorBannerList: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        usercode: undefined,
        mobile: undefined,
        openStatus: undefined,
      },
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询主播首页推荐列表 */
    getList() {
      this.loading = true;
      listAnchorBanner(this.queryParams).then(response => {
        this.anchorBannerList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.addAnchorBannerDialogVisible = true
      this.$nextTick(() => {
        this.$refs.addAnchorBannerDialog.init()
      })
    },
    handleOpenStatusChange(row){
      let text = row.openStatus === 0 ? '关闭' : '开启'
      this.$confirm('确认要' + text + '[' + row.nickname + ']开启视频吗?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        return updateAnchorBanner({ id: row.id, openStatus: row.openStatus })
      }).then(() => {
        this.$modal.msgSuccess(text + '成功')
      }).catch(function() {
        row.openStatus = row.openStatus === 1 ? 0 : 1
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除主播首页推荐的数据项？').then(() => {
        this.loading = true;
        return delAnchorBanner(ids);
      }).then(() => {
        this.loading = false;
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {
      }).finally(() => {
        this.loading = false;
      });
    },
  }
};
</script>
